<?php
//ini_set("display_errors",1);
//error_reporting(E_ALL);

defined ('_JEXEC') or die('Restricted access');

/**
 * abstract class for payment/shipment plugins
 *  
 * ING WebPay for VirtueMart Payment Plugin
 *   
 * @author SoftPill.Eu
 * @link http://www.softpill.eu
 * @copyright Copyright (c) 2012 - 2016 SoftPill.Eu. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.txt
 * This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * @version 1.0 March 2016
 */
if (!class_exists ('vmPSPlugin')) {
	require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
}

class plgVmPaymentINGWebPayForVirtuemart extends vmPSPlugin {

	function __construct (& $subject, $config) {

		parent::__construct ($subject, $config);
		// 		vmdebug('Plugin stuff',$subject, $config);
		$this->_loggable = TRUE;
		$this->tableFields = array_keys ($this->getTableSQLFields ());
		$this->_tablepkey = 'id';
		$this->_tableId = 'id';
		$varsToPush = $this->getVarsToPush ();
		$this->setConfigParameterable ($this->_configTableFieldName, $varsToPush);

	}

	/**
	 * Create the table for this plugin if it does not yet exist.
	 *
	 * @author Valérie Isaksen
	 */
	public function getVmPluginCreateTableSQL () {

		return $this->createTableSQL ('ING WebPay for VirtueMart');
	}

	/**
	 * Fields to create the payment table
	 *
	 * @return string SQL Fileds
	 */
	function getTableSQLFields () {

		$SQLfields = array(
			'id'                          => 'int(1) UNSIGNED NOT NULL AUTO_INCREMENT',
			'virtuemart_order_id'         => 'int(1) UNSIGNED',
			'order_number'                => 'char(64)',
			'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED',
			'payment_name'                => 'varchar(5000)',
			'payment_order_total'         => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\'',
			'payment_currency'            => 'char(3)',
			'email_currency'              => 'char(3)',
			'cost_per_transaction'        => 'decimal(10,2)',
			'cost_percent_total'          => 'decimal(10,2)',
			'tax_id'                      => 'smallint(1)',
      'payment_logos'               => 'varchar(255)',
      'username'                    => 'varchar(255)',
      'password'                    => 'varchar(255)',
      'description'                 => 'varchar(500)',
      'language'                    => 'char(2)',
      'status_pending'              => 'varchar(255)',
      'status_success'              => 'varchar(255)',
      'status_canceled'             => 'varchar(255)',
      'countries'                   => 'varchar(500)',
      'min_amount'                  => 'varchar(255)',
      'max_amount'                  => 'varchar(255)'
		);

		return $SQLfields;
	}
  function setParams($param_array,$comp_name)
  {
    if ( count($param_array) > 0 )
    {
      jimport('joomla.version');
      $jver = new JVersion();
      $jversion=$jver->getShortVersion();
      $joomla_ver=2;
      if(version_compare($jversion,'2.5','<'))
      {
        $joomla_ver=1;
      }
      if($joomla_ver==1)
      {
        $db = JFactory::getDbo();
        $params1=$this->getParams($comp_name);
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params="";
        foreach ( $params1 as $name => $value )
        {
          $params.=$name."=".$value."\n";
        }
        $db->setQuery('UPDATE #__plugins SET params = ' .
        $db->quote( $params ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
      else
      {
        $db = JFactory::getDbo();
        $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
        $params1 = json_decode( $db->loadResult(), true );
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params1String = json_encode( $params1 );
        $db->setQuery('UPDATE #__extensions SET params = ' .
        $db->quote( $params1String ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
    }
  }
  function getParams($comp_name)
  {
    jimport('joomla.version');
    $jver = new JVersion();
    $jversion=$jver->getShortVersion();
    $joomla_ver=2;
    if(version_compare($jversion,'2.5','<'))
    {
      $joomla_ver=1;
    }
    if($joomla_ver==1)
    {
      $params1=array();
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__plugins WHERE element = '.$db->quote($comp_name));
      $params=$db->loadResult();
      
      if($params!="")
      {
        $tarr=explode("\n",$params);
      }
      if(count($tarr)>0)
      {
        foreach($tarr as $p)
        {
          if($p!="")
          {
            $pos = strpos($p, "=");
            if ($pos === false) {}
            else
            {
              $key=substr($p,0,$pos);
              $val=substr($p,($pos+1),strlen($p));
              $params1[$key]=$val;
            }
          }
        }
      }
      return $params1;
    }
    else
    {
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
      $params1 = json_decode( $db->loadResult(), true );
      return $params1;
    }
  }
	function checkLicense($lic)
  {
    $checkurl='http://www.softpill.eu/check_complic.php?comp=ingwebpayforvirtuemart&h='.str_ireplace("www.","",$_SERVER['HTTP_HOST']).'&lic='.$lic;
    if (!function_exists('curl_init'))
    {
      $output=@file_get_contents($checkurl);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
    else
    {
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, $checkurl);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      $output = curl_exec($ch);
      curl_close($ch);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
  
    
    $application = JFactory::getApplication();
    if(@$ok==1)
    {
      $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
      $this->setParams(array('dchk'=>$chk,'ingwebpaylic'=>$lic),'ingwebpayforvirtuemart');
      $application->enqueueMessage('Thank You for Activating your ING WebPay - Payment Gateway', 'success');
      return 1;
    }
    else
    {
      //$this->setParams(array('ingwebpaylic'=>'','dchk'=>''),'ingwebpayforvirtuemart');
      $application->enqueueMessage('ING WebPay - Provided License code is wrong', 'error');
      return 0;
    }
  }
	/**
	 *
	 *
	 * @author Valérie Isaksen
	 */
	function plgVmConfirmedOrder ($cart, $order) {
    
    $params1  = $this->getParams('ingwebpayforvirtuemart');
    $dchk=$params1['dchk'];
    $lic=$params1['ingwebpaylic'];
    $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
    if($dchk!=$chk)
    {
      $application = JFactory::getApplication();
      if($lic=="")
      {
        $application->enqueueMessage('Please input your ING WebPay - Payment Gateway License Code', 'error');
        $this->setParams(array('ingwebpaylic'=>'','dchk'=>''),'ingwebpayforvirtuemart');
        return;
      }
      else
      {
        $dchk=@$params1['dchk'];
        if($dchk=='')
        {
          if(!$this->checkLicense($lic))
          {
            return;
          }
        }
        else
        {
//           $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
//           if($chk!=$dchk)//check
//           {
//             //$this->setParams(array('ingwebpaylic'=>'','dchk'=>''),'ingwebpayforvirtuemart');
//             $application->enqueueMessage('ING WebPay - Provided License code is wrong', 'error');
//             return;
//           }
        }
      }
    }
		if (!($method = $this->getVmPluginMethod ($order['details']['BT']->virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement ($method->payment_element)) {
			return FALSE;
		}

		VmConfig::loadJLang('com_virtuemart',true);
		VmConfig::loadJLang('com_virtuemart_orders', TRUE);

		if (!class_exists ('VirtueMartModelOrders')) {
			require(VMPATH_ADMIN . DS . 'models' . DS . 'orders.php');
		}

		$this->getPaymentCurrency($method);
		$currency_code_3 = shopFunctions::getCurrencyByID($method->payment_currency, 'currency_code_3');
		$email_currency = $this->getEmailCurrency($method);

		$totalInPaymentCurrency = vmPSPlugin::getAmountInCurrency($order['details']['BT']->order_total,$method->payment_currency);
    
    //do checks
    if (empty($method->username)) {
			vmInfo(JText::_('ING WebPay API Username Missing !!!'));
			return false;
		}
    if (empty($method->password)) {
			vmInfo(JText::_('ING WebPay API Password Missing !!!'));
			return false;
		}
    
		$dbValues['payment_name'] = $this->renderPluginName ($method);
		$dbValues['order_number'] = $order['details']['BT']->order_number;
		$dbValues['virtuemart_paymentmethod_id'] = $order['details']['BT']->virtuemart_paymentmethod_id;
		$dbValues['cost_per_transaction'] = $method->cost_per_transaction;
		$dbValues['cost_min_transaction'] = $method->cost_min_transaction;
		$dbValues['payment_currency'] = $currency_code_3;
		$dbValues['email_currency'] = $email_currency;
		$dbValues['payment_order_total'] = $totalInPaymentCurrency['value'];
		$dbValues['tax_id'] = $method->tax_id;
		$this->storePSPluginInternalData ($dbValues);
		if (!class_exists ('VirtueMartModelCurrency')) {
			require(VMPATH_ADMIN . DS . 'models' . DS . 'currency.php');
		}
		$currency = CurrencyDisplay::getInstance ('', $order['details']['BT']->virtuemart_vendor_id);
    
    
		$modelOrder = VmModel::getModel ('orders');
		$order['order_status'] = $this->getNewStatus ($method);
		$order['customer_notified'] = 1;
		$order['comments'] = '';
		$modelOrder->updateStatusForOneOrder ($order['details']['BT']->virtuemart_order_id, $order, TRUE);
    
    //populate $html
    $wp_config = array();
    $wp_config['ordernumber']=$order['details']['BT']->order_number;
    $wp_config['username']=$method->username;
    $wp_config['password']=$method->password;
    $wp_config['return_url']=JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id."&on=".$order['details']['BT']->order_number);
		$wp_config['test_indicator']=$method->test_indicator;
    $wp_config['check_amount']=1;
    $wp_config['sale_amount']=$totalInPaymentCurrency['value'];
    $wp_config['language']=$method->language;
    //$wp_config['certificate']=JPATH_BASE.'/plugins/vmpayment/ingwebpayforvirtuemart/ingwebpayforvirtuemart/certificate.pem';
    if ($wp_config['test_indicator'] == 1) {
    	/*
    	 * Use test environment; please note that you must use test cards, and the authorized transactions are not real
    	 */
    	$wp_config['post_action']       = 'https://securepay-uat.ing.ro/mpi_uat/rest/register.do';
    	$wp_config['order_status']      = 'https://securepay-uat.ing.ro/mpi_uat/rest/getOrderStatus.do';
    } else {
    
    	/*
    	 * Use production environment; please note that you must use production cards, and the authorized transactions are real
    	 */
    	$wp_config['post_action']       = 'https://securepay.ing.ro/mpi/rest/register.do';
    	$wp_config['order_status']      = 'https://securepay.ing.ro/mpi/rest/getOrderStatus.do';
    }
    if (($wp_config['username'] == '') || ($wp_config['password'] == '')) {
    	vmInfo(JText::_("Configuration error: initial parameters 'username' and 'password' were are set up. Please fill in the required initialisation parameters in config.webpay.php."));
      return false;
    }
    
    if (($wp_config['return_url'] == 'http://localhost/finishPayment.php') && ($wp_config['test_indicator'] != 1)) {
    	vmInfo(JText::_("Configuration error: initial parameter 'return_url' is not properly set up. Current value: $wp_config[return_url]. Please fill in a proper 'return_url' variable in config.webpay.php."));
      return false;
    }
    
    if ((!filter_var($wp_config['return_url'], FILTER_VALIDATE_URL)) && ($wp_config['test_indicator'] != 1)) {
    	vmInfo(JText::_("Configuration error: initial parameter 'return_url' is not a properly formatted URL. Current value: $wp_config[return_url]. Please fill in a proper 'return_url' variable in config.webpay.php."));
      return false;
    }
    
    if (($wp_config['test_indicator'] != 0) && ($wp_config['test_indicator'] != 1)) {
    	vmInfo(JText::_("Configuration error: initial parameter 'test_indicator' can only be 1 or 0. Please fill in the 'test_indicator' variable in config.webpay.php."));
      return false;
    }
    
    if (($wp_config['check_amount'] != 0) && ($wp_config['check_amount'] != 1)) {
    	vmInfo(JText::_("Configuration error: initial parameter 'check_amount' can only be 1 or 0. Please fill in the 'check_amount' variable in config.webpay.php."));
      return false;
    }
    
    if (($wp_config['language'] != 'ro') && ($wp_config['language'] != 'en')) {
    	vmInfo(JText::_("Configuration error: initial parameter 'language' is not properly set up. Please fill in the 'language' variable in config.webpay.php. with either 'ro' or 'en'."));
      return false;
    }
    
    $ING_currency=array('EUR'=>'978','RON'=>'946');
    //INGWebpayForVM
    $webpay = new INGWebpayForVM($wp_config);
    $response_detail = array();
    $webpay->setAmount($wp_config['sale_amount']);            //order amount is required
    $webpay->setCurrency($ING_currency[$currency_code_3]);        //order currency is required
    $webpay->setDescription($method->description);  //order description not required
    
    //get order id
    $response = $webpay->sendRequest();
    
    if(!$response['success']) {
        //request unsuccessful
        vmInfo(JText::_("ING WebPay system error: the request could not be completed! $response[result]"));
        return false;
    }
    else {
    	// request successful; uncomment this code to access the order id assigned by ING for this order
    	/*
    	$response_detail = json_decode($response['result'], true);
    	if (array_key_exists('orderId', $response_detail)) {
    		//$response_detail['orderId'] contains the value assigned by ING for the order. Please store this value into your database
    		//so that you may be able to find out in finishPayment.php the order for which you received response from ING
    		echo 'order id is:' . $response_detail['orderId']; die();
    	} elseif ((array_key_exists('errorCode', $response_detail)) && (array_key_exists('errorMessage', $response_detail))) {
    		//there was an error in initialising the transaction
    		$webpay->errorDie("ING WebPay system error: there was an error in initialising the transaction. Error code: $response_detail[errorCode], error message: $response_detail[errorMessage].");		
    	} else {
    		// Unknown error #return #API #response_detail
    		$webpay->errorDie('ING WebPay system error: an unknown error has been encountered in processing, at location tagged with #return #API #response_detail in initiateOrder.php.');
    	}
    	*/
      $html='<h1>'.JText::_("VMPAYMENT_INGWEBPAY_REDIRECTING").'</h1>';
      $html.= ' <script type="text/javascript">';
  		$html.= ' window.location = "'.$webpay->processResponse($response).'";';
  		$html.= ' </script>';
    }
    //We delete the old stuff
		//$cart->emptyCart ();
		vRequest::setVar ('html', $html);
		return TRUE;
	}
  function plgVmOnPaymentResponseReceived(&$html) {
    if (!class_exists('VirtueMartCart')) {
			require(VMPATH_SITE . DS . 'helpers' . DS . 'cart.php');
		}
		if (!class_exists('shopFunctionsF')) {
			require(VMPATH_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
		}
		if (!class_exists('VirtueMartModelOrders')) {
			require(VMPATH_ADMIN . DS . 'models' . DS . 'orders.php');
		}
		VmConfig::loadJLang('com_virtuemart_orders', TRUE);

		// the payment itself should send the parameter needed.
		$virtuemart_paymentmethod_id = vRequest::getInt('pm', 0);

		$order_number = vRequest::getString('on', 0);
		$vendorId = 0;
    
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return NULL;
		}

		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
			return NULL;
		}
		if (!($payments = $this->getDatasByOrderNumber($order_number))) {
			return '';
		}
		$payment_name = $this->renderPluginName($method);
		$payment = end($payments);

		VmConfig::loadJLang('com_virtuemart');
		$modelOrder = VmModel::getModel('orders');
		$order = $modelOrder->getOrder($virtuemart_order_id);
    
		if (!class_exists('CurrencyDisplay')) {
			require(VMPATH_ADMIN . DS . 'helpers' . DS . 'currencydisplay.php');
		}
		$currency = CurrencyDisplay::getInstance('', $order['details']['BT']->order_currency);
		
    $totalInPaymentCurrency = vmPSPlugin::getAmountInCurrency($order['details']['BT']->order_total,$method->payment_currency);
		$html = $this->renderByLayout('post_payment', array(
			'order_number' =>$order['details']['BT']->order_number,
			'order_pass' =>$order['details']['BT']->order_pass,
			'payment_name' => $payment_name,
			'displayTotalInPaymentCurrency' => $totalInPaymentCurrency['display']
		));
    //update order status
    $wp_config = array();
    $wp_config['username']=$method->username;
    $wp_config['password']=$method->password;
		$wp_config['test_indicator']=$method->test_indicator;
    if ($wp_config['test_indicator'] == 1) {
    	/*
    	 * Use test environment; please note that you must use test cards, and the authorized transactions are not real
    	 */
    	$wp_config['post_action']       = 'https://securepay-uat.ing.ro/mpi_uat/rest/register.do';
    	$wp_config['order_status']      = 'https://securepay-uat.ing.ro/mpi_uat/rest/getOrderStatus.do';
    } else {
    
    	/*
    	 * Use production environment; please note that you must use production cards, and the authorized transactions are real
    	 */
    	$wp_config['post_action']       = 'https://securepay.ing.ro/mpi/rest/register.do';
    	$wp_config['order_status']      = 'https://securepay.ing.ro/mpi/rest/getOrderStatus.do';
    }
    $orderId = preg_replace("/[^a-zA-Z0-9-]/", "", $_REQUEST['orderId']);
    
    $webpay = new INGWebpayForVM($wp_config);
    $webpay->setOrder($orderId);
    $message = $webpay->getOrderStatus();
    if ((array_key_exists('OrderStatus', $message)) && ($message['OrderStatus']==2))
    {
      //paid
      $update=array();
      $update['customer_notified']=1;
      $update['order_status'] = $method->status_success;
			$nb_history = count($order['history']);
			if ($order['history'][$nb_history - 1]->order_status_code != $update['order_status']) {
				$update['virtuemart_order_id'] = $virtuemart_order_id;
				$update['comments'] = JText::sprintf('Email sent');
				$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $update, true);
        $mainframe = JFactory::getApplication();
        $mainframe->enqueueMessage($message['order_status']);
			}
    }
    else
    {
      //cancel
      $update=array();
      $update['customer_notified']=1;
      $update['order_status'] = $method->status_canceled;
			$nb_history = count($order['history']);
			if ($order['history'][$nb_history - 1]->order_status_code != $update['order_status']) {
				$update['virtuemart_order_id'] = $virtuemart_order_id;
				$update['comments'] = JText::sprintf('Email sent');
				$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $update, true);
        $mainframe = JFactory::getApplication();
        $mainframe->enqueueMessage($message['order_status'],'error');
			}
    }
		//We delete the old stuff
		// get the correct cart / session
		$cart = VirtueMartCart::getCart();
		$cart->emptyCart();
		return TRUE;
  }
  function divideFloat($a, $b, $precision=2) {
      $a*=pow(10, $precision);
      $result=(int)($a / $b);
      if (strlen($result)==$precision) return '0.' . $result;
      else return preg_replace('/(\d{' . $precision . '})$/', '.\1', $result);
  }
	/*
		 * Keep backwards compatibility
		 * a new parameter has been added in the xml file
		 */
	function getNewStatus ($method) {

		if (isset($method->status_pending) and $method->status_pending!="") {
			return $method->status_pending;
		} else {
			return 'P';
		}
	}

	/**
	 * Display stored payment data for an order
	 *
	 */
	function plgVmOnShowOrderBEPayment ($virtuemart_order_id, $virtuemart_payment_id) {

		if (!$this->selectedThisByMethodId ($virtuemart_payment_id)) {
			return NULL; // Another method was selected, do nothing
		}

		if (!($paymentTable = $this->getDataByOrderId ($virtuemart_order_id))) {
			return NULL;
		}
		VmConfig::loadJLang('com_virtuemart');

		$html = '<table class="adminlist table">' . "\n";
		$html .= $this->getHtmlHeaderBE ();
		$html .= $this->getHtmlRowBE ('COM_VIRTUEMART_PAYMENT_NAME', $paymentTable->payment_name);
		$html .= $this->getHtmlRowBE ('INGWEBPAY_PAYMENT_TOTAL_CURRENCY', $paymentTable->payment_order_total . ' ' . $paymentTable->payment_currency);
		if ($paymentTable->email_currency) {
			$html .= $this->getHtmlRowBE ('INGWEBPAY_EMAIL_CURRENCY', $paymentTable->email_currency );
		}
		$html .= '</table>' . "\n";
		return $html;
	}

	/*	function getCosts (VirtueMartCart $cart, $method, $cart_prices) {

			if (preg_match ('/%$/', $method->cost_percent_total)) {
				$cost_percent_total = substr ($method->cost_percent_total, 0, -1);
			} else {
				$cost_percent_total = $method->cost_percent_total;
			}
			return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
		}
	*/
	/**
	 * Check if the payment conditions are fulfilled for this payment method
	 *
	 * @author: Valerie Isaksen
	 *
	 * @param $cart_prices: cart prices
	 * @param $payment
	 * @return true: if the conditions are fulfilled, false otherwise
	 *
	 */
	protected function checkConditions ($cart, $method, $cart_prices) {

		$this->convert_condition_amount($method);
		$amount = $this->getCartAmount($cart_prices);
		$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);


		//vmdebug('standard checkConditions',  $amount, $cart_prices['salesPrice'],  $cart_prices['salesPriceCoupon']);
		$amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
			OR
			($method->min_amount <= $amount AND ($method->max_amount == 0)));
		if (!$amount_cond) {
			return FALSE;
		}
		$countries = array();
		if (!empty($method->countries)) {
			if (!is_array ($method->countries)) {
				$countries[0] = $method->countries;
			} else {
				$countries = $method->countries;
			}
		}

		// probably did not gave his BT:ST address
		if (!is_array ($address)) {
			$address = array();
			$address['virtuemart_country_id'] = 0;
		}

		if (!isset($address['virtuemart_country_id'])) {
			$address['virtuemart_country_id'] = 0;
		}
		if (count ($countries) == 0 || in_array ($address['virtuemart_country_id'], $countries) ) {
			return TRUE;
		}

		return FALSE;
	}


	/*
* We must reimplement this triggers for joomla 1.7
*/

	/**
	 * Create the table for this plugin if it does not yet exist.
	 * This functions checks if the called plugin is active one.
	 * When yes it is calling the standard method to create the tables
	 *
	 * @author Valérie Isaksen
	 *
	 */
	function plgVmOnStoreInstallPaymentPluginTable ($jplugin_id) {

		return $this->onStoreInstallPluginTable ($jplugin_id);
	}

	/**
	 * This event is fired after the payment method has been selected. It can be used to store
	 * additional payment info in the cart.
	 *
	 * @author Max Milbers
	 * @author Valérie isaksen
	 *
	 * @param VirtueMartCart $cart: the actual cart
	 * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
	 *
	 */
	public function plgVmOnSelectCheckPayment (VirtueMartCart $cart, &$msg) {

		return $this->OnSelectCheck ($cart);
	}

	/**
	 * plgVmDisplayListFEPayment
	 * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
	 *
	 * @param object  $cart Cart object
	 * @param integer $selected ID of the method selected
	 * @return boolean True on succes, false on failures, null when this plugin was not selected.
	 * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
	 *
	 * @author Valerie Isaksen
	 * @author Max Milbers
	 */
	public function plgVmDisplayListFEPayment (VirtueMartCart $cart, $selected = 0, &$htmlIn) {

		return $this->displayListFE ($cart, $selected, $htmlIn);
	}

	/*
* plgVmonSelectedCalculatePricePayment
* Calculate the price (value, tax_id) of the selected method
* It is called by the calculator
* This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
* @author Valerie Isaksen
* @cart: VirtueMartCart the current cart
* @cart_prices: array the new cart prices
* @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
*
*
*/

	public function plgVmonSelectedCalculatePricePayment (VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {

		return $this->onSelectedCalculatePrice ($cart, $cart_prices, $cart_prices_name);
	}

	function plgVmgetPaymentCurrency ($virtuemart_paymentmethod_id, &$paymentCurrencyId) {

		if (!($method = $this->getVmPluginMethod ($virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement ($method->payment_element)) {
			return FALSE;
		}
		$this->getPaymentCurrency ($method);

		$paymentCurrencyId = $method->payment_currency;
		return;
	}

	/**
	 * plgVmOnCheckAutomaticSelectedPayment
	 * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
	 * The plugin must check first if it is the correct type
	 *
	 * @author Valerie Isaksen
	 * @param VirtueMartCart cart: the cart object
	 * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
	 *
	 */
	function plgVmOnCheckAutomaticSelectedPayment (VirtueMartCart $cart, array $cart_prices = array(), &$paymentCounter) {

		return $this->onCheckAutomaticSelected ($cart, $cart_prices, $paymentCounter);
	}

	/**
	 * This method is fired when showing the order details in the frontend.
	 * It displays the method-specific data.
	 *
	 * @param integer $order_id The order ID
	 * @return mixed Null for methods that aren't active, text (HTML) otherwise
	 * @author Max Milbers
	 * @author Valerie Isaksen
	 */
	public function plgVmOnShowOrderFEPayment ($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {

		$this->onShowOrderFE ($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
	}
	/**
	 * @param $orderDetails
	 * @param $data
	 * @return null
	 */

	function plgVmOnUserInvoice ($orderDetails, &$data) {

		if (!($method = $this->getVmPluginMethod ($orderDetails['virtuemart_paymentmethod_id']))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement ($method->payment_element)) {
			return NULL;
		}
		//vmdebug('plgVmOnUserInvoice',$orderDetails, $method);

		if (!isset($method->send_invoice_on_order_null) or $method->send_invoice_on_order_null==1 or $orderDetails['order_total'] > 0.00){
			return NULL;
		}

		if ($orderDetails['order_salesPrice']==0.00) {
			$data['invoice_number'] = 'reservedByPayment_' . $orderDetails['order_number']; // Nerver send the invoice via email
		}

	}
	/**
	 * @param $virtuemart_paymentmethod_id
	 * @param $paymentCurrencyId
	 * @return bool|null
	 */
	function plgVmgetEmailCurrency($virtuemart_paymentmethod_id, $virtuemart_order_id, &$emailCurrencyId) {

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return FALSE;
		}
		if (!($payments = $this->getDatasByOrderId($virtuemart_order_id))) {
			// JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		if (empty($payments[0]->email_currency)) {
			$vendorId = 1; //VirtueMartModelVendor::getLoggedVendor();
			$db = JFactory::getDBO();
			$q = 'SELECT   `vendor_currency` FROM `#__virtuemart_vendors` WHERE `virtuemart_vendor_id`=' . $vendorId;
			$db->setQuery($q);
			$emailCurrencyId = $db->loadResult();
		} else {
			$emailCurrencyId = $payments[0]->email_currency;
		}

	}
	/**
	 * This event is fired during the checkout process. It can be used to validate the
	 * method data as entered by the user.
	 *
	 * @return boolean True when the data was valid, false otherwise. If the plugin is not activated, it should return null.
	 * @author Max Milbers

	public function plgVmOnCheckoutCheckDataPayment(  VirtueMartCart $cart) {
	return null;
	}
	 */

	/**
	 * This method is fired when showing when priting an Order
	 * It displays the the payment method-specific data.
	 *
	 * @param integer $_virtuemart_order_id The order ID
	 * @param integer $method_id  method used for this order
	 * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
	 * @author Valerie Isaksen
	 */
	function plgVmonShowOrderPrintPayment ($order_number, $method_id) {

		return $this->onShowOrderPrint ($order_number, $method_id);
	}

	function plgVmDeclarePluginParamsPaymentVM3( &$data) {
		return $this->declarePluginParams('payment', $data);
	}
	function plgVmSetOnTablePluginParamsPayment ($name, $id, &$table) {

		return $this->setOnTablePluginParams ($name, $id, $table);
	}

	//Notice: We only need to add the events, which should work for the specific plugin, when an event is doing nothing, it should not be added

	/**
	 * Save updated order data to the method specific table
	 *
	 * @param array   $_formData Form data
	 * @return mixed, True on success, false on failures (the rest of the save-process will be
	 * skipped!), or null when this method is not actived.
	 *
	public function plgVmOnUpdateOrderPayment(  $_formData) {
	return null;
	}

	/**
	 * Save updated orderline data to the method specific table
	 *
	 * @param array   $_formData Form data
	 * @return mixed, True on success, false on failures (the rest of the save-process will be
	 * skipped!), or null when this method is not actived.
	 *
	public function plgVmOnUpdateOrderLine(  $_formData) {
	return null;
	}

	/**
	 * plgVmOnEditOrderLineBE
	 * This method is fired when editing the order line details in the backend.
	 * It can be used to add line specific package codes
	 *
	 * @param integer $_orderId The order ID
	 * @param integer $_lineId
	 * @return mixed Null for method that aren't active, text (HTML) otherwise
	 *
	public function plgVmOnEditOrderLineBEPayment(  $_orderId, $_lineId) {
	return null;
	}

	/**
	 * This method is fired when showing the order details in the frontend, for every orderline.
	 * It can be used to display line specific package codes, e.g. with a link to external tracking and
	 * tracing systems
	 *
	 * @param integer $_orderId The order ID
	 * @param integer $_lineId
	 * @return mixed Null for method that aren't active, text (HTML) otherwise
	 *
	public function plgVmOnShowOrderLineFE(  $_orderId, $_lineId) {
	return null;
	}

	/**
	 * This event is fired when the  method notifies you when an event occurs that affects the order.
	 * Typically,  the events  represents for payment authorizations, Fraud Management Filter actions and other actions,
	 * such as refunds, disputes, and chargebacks.
	 *
	 * NOTE for Plugin developers:
	 *  If the plugin is NOT actually executed (not the selected payment method), this method must return NULL
	 *
	 * @param         $return_context: it was given and sent in the payment form. The notification should return it back.
	 * Used to know which cart should be emptied, in case it is still in the session.
	 * @param int     $virtuemart_order_id : payment  order id
	 * @param char    $new_status : new_status for this order id.
	 * @return mixed Null when this method was not selected, otherwise the true or false
	 *
	 * @author Valerie Isaksen
	 *
	 *
	public function plgVmOnPaymentNotification() {
	return null;
	}

	/**
	 * plgVmOnPaymentResponseReceived
	 * This event is fired when the  method returns to the shop after the transaction
	 *
	 *  the method itself should send in the URL the parameters needed
	 * NOTE for Plugin developers:
	 *  If the plugin is NOT actually executed (not the selected payment method), this method must return NULL
	 *
	 * @param int     $virtuemart_order_id : should return the virtuemart_order_id
	 * @param text    $html: the html to display
	 * @return mixed Null when this method was not selected, otherwise the true or false
	 *
	 * @author Valerie Isaksen
	 *
	 *
	
	 */
  
}
/*
 * ING WebPay simple online playment handler
 *
 * 23/11/2014: added curl function existence verification & "if($curl == FALSE) {...}", in the same location, twice.
 * 23/11/2014: added OrderStatus variable to showMessage function and 'die' after sending redirect headers.
 * added also amount, currency and order status to showMessage return
 * 24/11/2014: fixed CAINFO problem; usually, if VERIFYPEER is used, php uses the default root CA to
 * verify certificates; however, if the system does not have proper root CA, then one may be indicated
 * with the use of CAINFO, but it needs to be the FIRST CA in the chain!
 * certificate.pem now contains the first Verisign certificate in the chain and works if CAINFO lines are
 * not commented.
 * 25/11/2014: added OrderNumber to showMessage; this is not currently used by merchants
 * 22-24/12/2014: updated some system error messages texts to have a more uniform approach to error responses; all "ING WebPay system error"s are in English, as they should be
 * encountered during technical setup or upon exceptional processing.
 * Added admin email and reporting email to the Webpay class as variables.
 * Added additional error messages to processResponse function, to treat situations when formUrl, errorMessage or errorCode
 * are not received as part of the curl result.
 * Verify if there was a curl error in getOrderStatus function.
 * In showMessage, verify if the orderStatus and errorMessage are returned, and mark the status variables with "not initialized"
 * if they are not set. This will prevent interpretation errors by the merchant code. Also, enhanced descriptions for 'order_status'
 * and 'error_message' to be in RO and EN, and to be displayed properly with a limit of 70 characters per line (for email).
 * Defined two functions: errorDie (to output error message and send it to admin email) and authMail (to send transaction status)
 * to reporting email.
 */

class INGWebpayForVM
{

    private $_amount            = "0.00";   //total order value
    private $_currency          = "946";    //order currency 946 for RON
    private $_order             = "";       //order_id (unique value)

    private $_description       = "";       //order description ex: "Order no #<order_id>"

    //config.webpay values
    private $_username          = "";
    private $_password          = "";
    private $_return_url        = "";
    private $_language          = "";
    private $_post_action       = "";
    private $_certificate       = "";
    private $_order_status      = "";
    private $_form_url          = "";
	private $_test_indicator 		= 0;

    public function INGWebpayForVM($config = array()) {

        $allowedConfig = array(
            'username', 'password', 'return_url', 'language', 'certificate', 'post_action', 'order_status', 'test_indicator', 'admin_email', 'reporting_email'
        );
        foreach($config as $key => $value) {
            if(in_array($key, $allowedConfig)) {
                $this->{'_' . $key} = trim($value);
            }
        }
    }

    /*
     * Set order amount (required)
     */
    public function setAmount($amount) {
        //transform to minor units ex: 123.45 => 12345, 1 => 100
        $amount = number_format($amount, 2, '.', '');
        $amount =  100 * $amount;
        $this->_amount = $amount;
    }

    /*
     * Set order currency (required) - 946 for RON => see http://en.wikipedia.org/wiki/ISO_4217 for full list
     */
    public function setCurrency($currency) {
        $this->_currency = $currency;
    }

    /*
     * Set order id
     */
    public function setOrder($order) {
        $this->_order = $order;
    }

    /*
     * Set order description
     */
    public function setDescription($description) {
        $this->_description = $description;
    }

    /*
     * Set form url
     * -after initial post, ING will provide an URL for the payment form
     */
    public function setFormUrl($formUrl) {
        $this->_form_url = $formUrl;
    }

    /*
     * Get post fields for order ID
     */
    public function getPostFields() {

        $postFields = array(
            'userName'          => $this->_username,
            'password'          => $this->_password,
            'currency'          => $this->_currency,
            'description'       => $this->_description,
            'amount'            => $this->_amount,
            'returnUrl'         => $this->_return_url,
            'language'          => $this->_language
        );

        return $postFields;
    }

    /*
     * Get post fields for order status
     */
    public function getOrderStatusFields() {

        $postFields = array(
            'userName'          => $this->_username,
            'password'          => $this->_password,
            'orderId'           => $this->_order
        );

        return $postFields;
    }

    /*
     * Get order id
     */
    public function sendRequest() {

        $postFields = $this->getPostFields();
//print_r($postFields);;exit;
        $curl = curl_init();
		// is cURL installed?
		if (!function_exists('curl_init')){
			$this->errorDie('ING WebPay system error: cURL is not installed!');
		}
    
		if($curl == FALSE) { echo 'ING WebPay system error: cannot initialize curl; curl_init result is: '; var_dump($curl); $this->errorDie('ING WebPay system error: cannot initialize curl in Webpay.php #sendRequest'); }
        curl_setopt($curl, CURLOPT_URL, $this->_post_action);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($curl, CURLOPT_POST, true);
		curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($postFields));

		/*
         * If we work on test system test_indicator = 1 then we don't verify the certificate
		 * if we work on production, we verify the CA of the certificate and CN
         * On production you must always verify the transaction in the ING WebPay user interface (GUI) if you ignore the certificate/host validation!
         */
		
		if ($this->_test_indicator == 0) {
			/* 
			 * we are on production, we verify the certificate of ING WebPay with a CA root certificate indicated in CAINFO and VERIFYPEER
			 * and we verify the CN of the ING WebPay certificate with VERIFYHOST
			 */
			// uncomment the following line if the server does not have own CA file
			//curl_setopt($curl, CURLOPT_CAINFO, $this->_certificate);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, true);
			curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);
		} else {
			// we are on test, we do not verify the certificate of ING WebPay and the CN from the certificate
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
		}

        $result = curl_exec($curl);

        if(curl_errno($curl)) {
            return array('result' => curl_error($curl), 'success' => false);
        }

        return array('result' => $result, 'success' => true);
    }

    /*
     * Get redirect URL from ING, and redirect to that location
     */

    public function processResponse($response) {

        $response = json_decode($response['result'], true);
		
		if (array_key_exists('formUrl', $response)) {
			$this->setFormUrl($response['formUrl']);
			header("Location: " . $response['formUrl']);
			die();
		} elseif ((array_key_exists('errorCode', $response)) && (array_key_exists('errorMessage', $response))) {
			//there was an error in initialising the transaction
			$this->errorDie("ING WebPay system error: there was an error in initialising the transaction: error code $response[errorCode], error message $response[errorMessage].");
		} else {
			// Unknown error #return #API #response #registerorder
			$this->errorDie('ING WebPay system error: an unknown error has been encountered in processing, at location tagged with #return #API #response #registerorder in Webpay.php.');
		}

    }
	
    /*
     * When the payment is complete get status for that order
     */
    public function getOrderStatus() {

        $postFields = $this->getOrderStatusFields();

        $curl = curl_init();
		// Verify if cURL is installed
		if (!function_exists('curl_init')){
			$this->errorDie('ING WebPay system error: cURL is not installed!');
		}
		if($curl == FALSE) { echo 'ING WebPay system error: cannot initialize curl; curl_init result is: '; var_dump($curl); $this->errorDie('ING WebPay system error: cannot initialize curl in Webpay.php #getOrderStatus'); }
        curl_setopt($curl, CURLOPT_URL, $this->_order_status);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
        curl_setopt($curl, CURLOPT_POST, true);
		curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($postFields));
        
		/*
         * If we work on test system test_indicator = 1 then we don't verify the certificate
		 * if we work on production, we verify the CA of the certificate and CN
         * On production you must always verify the transaction in the ING WebPay user interface (GUI) if you ignore the certificate/host validation!
         */
		
		if ($this->_test_indicator == 0) {
			/* 
			 * we are on production, we verify the certificate of ING WebPay with a CA root certificate indicated in CAINFO and VERIFYPEER
			 * and we verify the CN of the ING WebPay certificate with VERIFYHOST
			 */
			// uncomment the following line if the server does not have own CA file
			//curl_setopt($curl, CURLOPT_CAINFO, $this->_certificate);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, true);
			curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 2);
		} else {
			// we are on test, we do not verify the certificate of ING WebPay and the CN from the certificate
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
		}

        $result = curl_exec($curl);
        
        if(curl_errno($curl)) {
            echo curl_error($curl);
            echo 'ING WebPay system error: an error has occured. Please contact the website administrator.';
            $this->errorDie('ING WebPay system error: an error has occured #getOrderStatus #curl_exec #curl_errno');
        }
		
        return $this->showMessage(json_decode($result, true));
    }

    /*
     * Get message from order status
     */
    public function showMessage($response = array()) {
		
		$orderStatus = 'not initialised';
        if (array_key_exists('OrderStatus', $response)) {
			switch($response['OrderStatus']) {
				case 0:
					$orderStatus = "Tranzactia a fost inregistrata dar nu si autorizata." . "\r\n" . "(order registrered, but not paid off)";
					break;
				case 1:
					$orderStatus = "Pre-autorizarea a fost efectuata cu succes."  . "\r\n" . "(pre-authorisation of order amount was held; for two-stage payment)";
					break;
				case 2:
					$orderStatus = "Tranzactie autorizata. (order amount is fully authorized)";
					break;
				case 3:
					$orderStatus = "Autorizare anulata. (authorization canceled)";
					break;
				case 4:
					$orderStatus = "Tranzactia a fost returnata. (transaction was refunded)";
					break;
				case 5:
					$orderStatus = "Autentificare cu ACS initializata." . "\r\n" . "(initiated authorization using ACS of the issuer bank)";
					break;
				case 6:
					$orderStatus = "Autorizare refuzata. (authorization declined)";
					break;
			}
		}
		
        $errorMessage = 'not initialised';
        if (array_key_exists('ErrorCode', $response)) {
			switch($response['ErrorCode']) {
				case 0:
					$errorMessage = "Procesare efectuata cu succes. (successfully processed)";
					break;
				case 2:
					$errorMessage = "Tranzactie esuata din cauza detaliilor de plata introduse incorect." . "\r\n" . "(the order is declined because of an error in the payment credentials)";
					break;
				case 5:
					$errorMessage = "Valoare eronata a unui parametru din solicitare." . "\r\n" . "(erroneous value of a request parameter)";
					break;
				case 6:
					$errorMessage = "Order ID neinregistrat. (unregistered OrderId)";
					break;
			}
		}
		
		if ((array_key_exists('Amount', $response)) && (array_key_exists('currency', $response)) && (array_key_exists('OrderStatus', $response))) {
			return array('order_status' => $orderStatus, 'error_message' => $errorMessage, 'amount' => $response['Amount'], 'currency' => $response['currency'], 'OrderStatus' => $response['OrderStatus']);
		} else {
			return array('order_status' => $orderStatus, 'error_message' => $errorMessage);
		}
	
    }
	
    public function errorDie($message) {
		if($this->_admin_email != '') {
			$to = $this->_admin_email;
			$subject = "ING WebPay library error";
			$txt = "The following error was encountered by ING WebPay:\r\n";
			$txt .= "$message \r\n";
			$txt = wordwrap($txt, 70, "\r\n", true);
			$headers = "From: ". $to . "\r\n";
			mail($to,$subject,$txt,$headers);
		}
        die($message);
    }
	
	public function authMail($message) {
		if($this->_reporting_email != '') {
			$to = $this->_reporting_email;
			$subject = "Notificare ING WebPay";
			$txt = "Buna ziua,\r\n\r\n";
			$txt .= "Va informam ca pe platforma ING WebPay a fost efectuata o tranzactie cu cardul bancar. Mai jos puteti consulta detaliile disponibile pentru aceasta tranzactie.\r\n\r\n";
			$txt .= "$message \r\n";
			$txt = wordwrap($txt, 70, "\r\n", true);
			$headers = "From: ". $to ."\r\n";
			mail($to,$subject,$txt,$headers);
		}
    }
	
}
// No closing tag
